2.3 Canviant sintetitzadors

# Canviant sintetitzadors

Fins ara ho hem passat molt bé només fent sons. No obstant això, potser esteu començant a avorrir el so bàsic. És això tot el que pot oferir Sonic Pi? Hi ha alguna cosa més a fer a banda de tocar sorollets? És clar que sí, i en aquesta secció explorarem la gama de sons apassionant que Sonic Pi ofereix.

## Sintetitzadors

Sonic Pi té una gama d'instruments anomenats synths, que és la manera d'abreviar *sintetitzadors*. Mentre que les mostres representen sons pre-gravats, els sintetitzadors són capaços de generar sons nous depenent de com els controles (en parlarem més endavant en aquest tutorial). Els sintetitzadors de Sonic Pi són molt potents i expressius, gaudireu molt tocant i explorant-los. En primer lloc, aprenguem a seleccionar el sintetitzador que volem utilitzar.

## Serres brunzidores i profetes

Un so divertit és el de l'*ona de serra* - provem-lo:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
sleep 0.25
```

Provem un altre so - el profeta (*prophet*):

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
sleep 0.25
```

I si combinem ambdós sons? Posem-los un darrere l'altre:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
sleep 0.25
```

Ara diversos sons al mateix temps (s'aconsegueix no fent `sleep` entre les successives crides a `play`):

```
use_synth :tb303
play 38
sleep 0.25
use_synth :dsaw
play 50
sleep 0.25
use_synth :prophet
play 57
sleep 0.25
```

Noteu que l'ordre `use_synth`només afecta a les següents ordres de `play`. Penseu-lo com un *gran interruptor* - només ordres `play` tocaran l'últim sintetitzador que s'haja activat. Podeu canviar a un altre sintetitzador amb `use_synth`.


## Descobrint sintetitzadors

Per saber quins sintetitzadors té Sonic Pi, feu una ullada a l'opció Sintetitzadors del menú que hi ha a l'esquerra (al costat d'Efectes). Hi ha més de 20 opcions diferents. Ací teniu alguns dels meus favorits:

* `:prophet`
* `:dsaw`
* `:fm`
* `:tb303`
* `:pulse`

Ara proveu a *canviar els sintetitzadors mentre la música sona*. Xaleu combinant sintetitzadors per obtenir sons nous, així com fent servir diferents sintetitzadors per a diferents seccions de la música.
