3.3 Samples dehnen

# Samples dehnen

Jetzt können wir schon eine Reihe Synths und Samples spielen, um damit Musik zu machen. Es wird Zeit zu lernen, wie wir diese Synths und Samples verändern können, um unsere Musik einzigartiger und spannender zu gestalten. Als Erstes erkunden wir, wie sich Samples *strecken* und *stauchen* lassen.

## Samples Representation

Samples sind aufgenommene Klänge, gespeichert als eine Reihe von Zahlen, die repräsentieren wie die Lautsprechermembran sich bewegen muss, um den Klang wiederzugeben. Die Lautsprechermembran kann sich nach innen und nach außen bewegen und die Zahlen geben deshalb an, wie weit sich die Membran zu jedem Zeitpunkt nach innen oder außen bewegen muss. Um einen Klang als Aufnahme wirklichkeitsgetreu wiederzugeben, muss das Sample für jede Sekunde viele tausend Zahlen speichern! Sonic Pi nimmt diese Zahlenreihe und gibt sie in der richtigen Geschwindigkeit (sample rate) aus, um den Lautsprecher in deinem Computer genau so bewegen, dass der Klang richtig wiedergegeben wird. Es macht aber auch Spaß, die Geschwindigkeit mit der die Zahlen ausgegeben werden zu ändern, um den Klang zu verändern.

## Geschwindigkeit ändern

Lass uns mit einem der Ambient-Klänge spielen: `:ambi_choir`. Um die Standard-Geschwindigkeit zu verändern kannst du die Opt `rate:` an `sample` übergeben:

```
sample :ambi_choir, rate: 1
```

Das Sample wird unverändert mit der Standard-Geschwindigkeit (1) abgespielt, also nichts Besonderes. Aber wir können die Zahl jederzeit verändern. Wie wär's mit `0.5`?

```
sample :ambi_choir, rate: 0.5
```

Wow! Was ist denn jetzt los? Also, hier passieren zwei Dinge. Erstens braucht das Sample doppelt so lange und zweitens klingt er eine Oktave niedriger. Sehen wir uns das ein bisschen genauer an.

## Lasst uns stretchen

Mit dem Amen-Break-Sample macht das Strecken und Stauchen besonders viel Spaß. Bei normaler Geschwindigkeit würden wir es vielleicht in einem *Drum 'n' Bass*-Track verwenden:

```
sample :loop_amen
```

Aber mit einer anderen Geschwindigkeit passt es auch zu anderen Stilen. Probiere es aus mit halber Samplerate für *Hip-Hop alter Schule*:

```
sample :loop_amen, rate: 0.5
```

Wenn wir es beschleunigen, erreichen wir *Jungle*-Territorium:

```
sample :loop_amen, rate: 1.5
```

Und als letzten Party-Trick - schauen wir mal, was passiert, wenn wir eine negative Rate angeben:

```
sample :loop_amen, rate: -1
```

Wow! Das Sample spielt *rückwärts*! Jetzt probiere mit vielen unterschiedlichen Samples und unterschiedlichen Sampleraten herum. Versuch es mit sehr hohen oder mit verrückt langsamen Geschwindigkeiten. Finde heraus, welche spannenden Klänge du produzieren kannst.

## Eine einfache Erklärung der Samplerate

Ein nützlicher Weg ist sich Samples als Sprungfedern vorzustellen. Samplerate (auch Abtastrate) ist, als ob man die Sprungfeder zusammendrückt oder auseinanderzieht. Wenn du ein Sample mit derRate 2 abspielst, *drückst du die Feder* zusammen, bis sie nur noch die Hälfte ihrer normalen Länge hat. Das Sample braucht nur die Hälfte der Abspielzeit, weil es kürzer ist. Wenn du das Sample mit halber Rate abspielst, *ziehst du die Feder* auf ihre doppelte Länge auseinander. Das Sample braucht nun doppelt so lange, weil es länger ist. Je mehr Du quetscht (höhere Rate), desto kürzer das Sample, je mehr du streckst (geringere Rate), desto länger das Sample.

Wenn du eine Sprungfeder zusammendrückt, erhöhst du ihre Dichte (die Anzahl der Windungen je Zentimeter) - das entspricht einem Sample, das *höher klingt*. Wenn du die Sprungfeder auseinanderziehst, verringerst du ihre Dichte, entspricht das einem, das *tiefer klingt*.


## Die Mathematik hinter der Samplerate

(Dieser Abschnitt ist für diejenigen gedacht, die an den Details interessiert sind. Er kann gerne übersprungen werden...)

Wie wir oben gesehen haben, wird ein Sample durch eine lange Reihe von Zahlen dargestellt, die der Lautsprechermembran sagen, wo sie im Verlauf der Zeit sein soll. Wir können diese Zahlenreihe nehmen, um eine Kurve zu zeichnen, die ungefähr so aussieht:

![Beispielhafter Kurvenverlauf](../../../etc/doc/images/tutorial/sample.png)

Vielleicht hast du Bilder wie dieses schon einmal gesehen. Das ist die *Waveform* (Wellenform) eines Samples. Es ist einfach eine Kurve aus Zahlenwerten. Typischerweise besteht eine Kurve wie diese aus 44100 Datenpunkten je Sekunde (das hat mit dem Nyquist-Shannon-Abtasttheorem zu tun). Wenn also das Sample 2 Sekunden dauert, dann wird die Kurve aus 88200 Zahlen gebildet, die wir an den Lautsprecher mit einer Rate von 44100 Datenpunkten pro Sekunde senden. Natürlich könnten wir das Sample mit der doppelten Abtastrate senden, also 88200 Datenpunkten pro Sekunde. Dann würde das Sample nur eine Sekunde lang dauern. Wir können es auch mit der halben Rate abspielen; das wären dann 22050 Datenpunkte pro Sekunde und würde 4 Sekunden dauern.

Die Dauer des Samples ist abhängig von der Abtastrate:

* Wird die Abtastrate verdoppelt, halbiert das die Abspielzeit,
* Wird die Abtastrate halbiert, dann verdoppelt das die Abspielzeit,
* Eine Abtastrate von einem Viertel vervierfacht die Abspielzeit,
* Bei Verwendung einer Abtastrate von 1/10 dauert die Abspielzeit 10 mal länger.

Wir können das in einer Formel abbilden:

```
neue_sample_dauer = (1 / rate) * sample_dauer 
```

Eine Veränderung der Samplerate beeinflusst auch die Tonhöhe des Samples. Die Frequenz oder Tonhöhe einer Kurve wird dadurch bestimmt, wie schnell sie hoch und runter geht. Unser Gehirn macht aus schnellen Bewegungen einer Lautsprechermembran hohe Töne und aus langsamen tiefe Töne. Deshalb kannst du manchmal sogar sehen, wie sich ein großer Basslautsprecher bewegt, wenn er einen sehr tiefen Ton ausgibt - tatsächlich bewegt er sich dann wesentlich langsamer als ein Lautsprecher, der hohe Töne wiedergibt.

Wenn du eine Wellenform nimmst und sie zusammendrückst, wird sie in jeder Sekunde häufiger hoch und runter gehen. Das lässt den Ton höher klingen. Es zeigt sich, dass die Tonhöhe sich verdoppelt, wenn die Auf- und Abbewegungen pro Sekunde (Oszillationen) verdoppelt werden. Also, *wenn du dein Sample mit doppelter Rate abspielst, wird es auch doppelt so hoch klingen*, und anders herum wird *eine Halbierung der Rate die Frequenz halbieren*. Entsprechend werden auch andere Raten die Tonhöhe beeinflussen.
