3.3 Estirando Samples

# Estirando Samples

Ahora que ya podemos tocar una variedad de sintetizadores y samples para crear música, es tiempo de aprender a modificar tanto los sintetizadores como los samples para hacer la música incluso más interesante y única. Primero, exploremos la habilidad de *estirar* y *aplastar* los samples.

## Representación de Samples

Los Samples son sonidos pregrabados guardados como números que representan cómo mover los conos de los parlantes para reproducir sonidos. Estos conos se pueden mover hacia dentro y hacia afuera, así que los números sólo deben representar ese movimiento en cada momento dado. Para poder reproducir fielmente un sonido, el sample debe guardar miles de números por segundo! Sonic Pi toma esta lista de números y los alimenta a la velocidad correcta para mover los parlantes de tu ordenador a la velocidad correcta para reproducir el sonido. Sin embargo, también es divertido cambiar la velocidad a la que los números son alimentados al parlante para cambiar el sonido.

## Cambiando la Velocidad

Vamos a cambiar uno de los sonidos ambientales: `:ambi_choir`. Para la modificación de la velocidad por defecto, se puede agregar `rate:` a la `sample`:

```
sample :ambi_choir, rate: 1
```

Esto lo ejecuta a tiempo normal (1), nada especial. Sin embargo, podemos cambiar ese número por algo más. ¿Qué tal a `0.5`?:

```
sample :ambi_choir, rate: 0.5
```

¡Woah! ¿qué sucedió? Bueno, dos cosas: Primero, el sample se ejecutó en el doble del tiempo; Segundo, sonó una octava más grave. Exploremos todo esto en más detalle.

## Estiremos

Un sample que es divertido estirar y comprimir es el Amen Break. A velocidad normal, podemos imaginar ponerlo en una pista de *drum 'n' bass*:

```
sample :loop_amen
```

Sin embargo, cambiando la velocidad podemos cambiar géneros. Intenta con la mitad de la velocidad para algo de "hip hop de la vieja escuela":

```
sample :loop_amen, rate: 0.5
```

Si lo aceleramos, entramos al territorio de *jungle*:

```
sample :loop_amen, rate: 1.5
```

Vamos a nuestro último truco - veamos qué sucede si utilizamos una velocidad negativa:

```
sample :loop_amen, rate: -1
```

Ahaa! ¡Se toca *al revés*! Ahora intenta tocar distintos samples a distintas velocidades. Intenta con velocidades muy rápidas o lentísimas. Observa qué sonidos interesantes puedes crear.

## Velocidad de Sample: Una explicación sencilla

Una manera útil de pensar en samples es comparándolos con resortes. Piensa en la velocidad de ejecución como "estirar" o "comprimir" el resorte. Si tocas a velocidad 2 estás *comprimiendo el resorte* a la mitad de su tamaño, por tanto le toma la mitad del tiempo en ejecutarse, ya que es más corto. Si ejecutas el sample a la mitad de velocidad, estás en efecto *alargando el resorte*, por tanto estás doblando su tamaño y el tiempo que le toma ejecutarse. Entre más comprimas (mayor velocidad), más corto se vuelve, entre más estires (menor velocidad), más largo se vuelve.

Comprimir un resorte incrementa su densidad (el número de "vueltas" por cm.) - esto es similar al sample sonando más *agudo*. Estirar el resorte disminuye su densidad y es similar al sonido siendo más *grave*.


## La matemática detrás de la velocidad de sample

(Esta sección es para aquellos interesados en los detalles. Eres libre de saltártela...)

Como hemos visto, un sample está representado por una larga lista de números representando donde debe de estar el parlante a través del tiempo. Podemos tomar este listado de números y usarlo para dibujar un gráfico que sería similar a:

![gráfica de muestra](../../../etc/doc/images/tutorial/sample.png)

Quizás hayas visto imágenes parecidas a esa. Se llaman "forma de onda" de un sampleo. Simplemente es la graficación de números. Típicamente una forma de onda como ésta tendrá 44100 puntos por segundo de datos (esto es debido al teorema de sampleo de Nyquist-Shannon) Así que si el sampleo dura 2 segundos, la forma de onda será representada por 88200 números, alimentándo al altavoz a una velocidad de 44100 puntos por segundo. Claro, podemos también alimentarlos a una velocidad doble, que sería de 88200 puntos por segundo, lo cual tomaría sólo 1 segundo para ser tocado. También podríamos tocarlo a la mitad de velocidad, lo que daría 22050 puntos por segundo tomando 4 segundos de tiempo de ejecución.

La duración del sampleo es afectada por la velocidad de ejecución:

* Doblando la velocidad de reproducción se reduce a la mitad el tiempo de ejecución,
* cortando a la mitad la reproducción, doblamos el tiempo de ejecución,
* usando una velocidad de ejecución de 1/4, cuadruplicamos el tiempo de reproducción,
* El uso de una velocidad de reproducción de 1/10, hace que la reproducción dure 10 veces más.

Podemos representar esto con la fórmula:

```
nuevo_sample_ = (1 / velocidad) * duración_sample 
```

Cambiando la velocidad de ejecución se afecta el tono del muestreo. La frecuencia o tono de una onda está determinada por cuán rápido se mueve hacia arriba y hacia abajo. De alguna manera, nuestro cerebro toma los movimientos rápidos de los parlantes a notas agudas, igualmente, torna movimientos lentos de los parlantes en notas graves. Por eso es que puedes ver los parlantes de bajos moverse cuando están dando notas muy bajas, porque en realidad sí se están moviendo adentro/afuera del parlante mucho más lentamente que al producir notas altas.

Si tomas una forma de onda y la comprimes en el eje de las "x"(tiempo), se moverá más veces por segundo hacia arriba y hacia abajo, lo que producirá un sonido más agudo. Significa que doblando la cantidad de movimientos verticales (oscilaciones) se dobla la frecuencia. Así: *tocar tu onda sonora al doble de velocidad, doblará la frecuencia a la que la escuchas*. Asimismo, *reduciendo la velocidad a la mitad, también reduce la frecuencia a la mitad*. En consecuencia, cambios en las velocidades afectarán la frecuencia.
