1.2 Esploriamo l’interfaccia

# L’interfaccia di Sonic Pi

Sonic Pi ha un’interfaccia molto semplice per programmare la musica. Diamogli un’occhiata.

![Sonic Pi Interface](../../../etc/doc/images/tutorial/GUI.png)


* *A* - Controlli di riproduzione
* *B* - Controlli di modifica
* *C* - Info e Help
* *D* - Editor del codice
* *E* - Pannello preferenze
* *F* - Visualizzatore Messaggi
* *G* - Sistema d'aiuto
* *H* - Visualizzatore di segnale
* *I* - Visualizzatore Messaggi

## A. Controlli di riproduzione

Questi tasti rosa sono i controlli principali per far partire o fermare i suoni. Il tasto *Run* esegue il codice che hai scritto nell’editor, *Stop* ferma tutto il codice in esecuzione, *Save* per salvare il codice in un file esterno e *Record* per registrare (in un file WAV) i suoni riprodotti.

## B. Controlli di modifica

Questi pulsanti arancioni ti permettono di modificare l'interfaccia. I pulsanti *Size +* e *Size -* ti permettono di ingrandire o rimpicciolire il testo.

## C. Info e Help

Questi tasti blu ti danno accesso alle informazioni, all’aiuto e alle opzioni. Il tasto *Info* apre la finestra delle informazioni che contiene le notizie su Sonic Pi, il team di sviluppo, la storia, i collaboratori e la community. Il tasto *Help* apre e chiude l’help (*G*) e il tasto *Prefs* apre e chiude la finestra delle opzioni che ti permette di modificare alcune impostazioni di base del programma.

## D. Editor del codice

Questa è l’area dove scriverai il tuo codice e comporrai/eseguirai la tua musica. È un semplice editor di testo dove puoi scrivere le tue istruzioni, cancellarle, copiarle e incollarle etc. Pensalo come una versione molto elementare di Word o Google Docs. L’editor cambia il colore delle parole sulla base del loro significato nel linguaggio. Questo all’inizio può sembrare strano, ma presto ti accorgerai che è molto utile. Per esempio, qualunque testo colorato di blu è sicuramente un numero.

## E. Pannello delle preferenze

Attraverso il tasto *prefs* nel gruppo di tasti Info e Help, puoi accedere alle opzioni di configurazione di Sonic Pi. Questo tasto ti permette di aprire e chiudere la finestra delle preferenze che possono essere modificate. Per esempio, forzare la modalità mono, invertire i canali stereo, modificare il livello di dettaglio dei messaggi di log e c'è anche un cursore per il livello del suono in uscita e un selettore audio se stai usando un Raspberry Pi.

## F. Visualizzatore messaggi

Quando i tuoi programmi girano, le informazioni su cosa stiano facendo vengono visualizzate nella finestra di log. Di default, noterai che c’è un messaggio per ogni suono che generi e che riporta il tempo esatto in cui il suono viene prodotto. Vedrai che questo ti sarà molto utile quando dovrai fare il debug, ovvero individuare gli errori, del tuo codice o capire cosa sta facendo il tuo programma.

## G. Sistema di aiuto

Infine, una delle parti più importanti dell’interfaccia di Sonic Pi è la sezione Help che appare in basso nella finestra del programma. Puoi attivarla o disattivarla usando il tasto *Help*. La sezione Help contiene aiuti e informazioni su tutti gli aspetti di Sonic Pi, compreso questo tutorial, una lista dei sintetizzatori e dei campioni disponibili, esempi, effetti (FX) ed una lista completa di tutte le funzioni e le istruzioni disponibili nel linguaggio di Sonic Pi.

## H. Visualizzatore di segnale

Il visualizzatore di segnale ti permette di "guardare" il suono che stai ascoltando. Poi osservare facilmente che l'onda a dente di sega ha davvero la forma di una sega e che il beep è una curva della funzione seno. Puoi inoltre distinguere i suoni forti dai suoni deboli osservando la grandezza delle linee. Ci sono tre sezioni a disposizione: la predefinita è dedicata alla combinazione dei canali destro e sinistro, poi c'è quella che permette di visualizzare i due canali separatamente e infine c'è la sezione che mostra la "figura di Lissajous". Quest'ultima indica la relazione parametrica fra canale sinistro e canale destro, inoltre ti permette di disegnare delle forme geometriche con il suono (https://en.wikipedia.org/wiki/Lissajous_curve).

## F. Visualizzatore messaggi

Tutti gli eventi interni ed esterni (denominati cues in Sonic Pi) sono automaticamente registrati nel Cue Viewer. Ad esempio, se hai un controller MIDI collegato e premi uno dei suoi tasti, vedrai un nuovo evento cue nel Cue Viewer che mostra il nome del controller e il valore del tasto premuto. Una volta acquisita la padronanza mase per creare e riprodurre suoni, comincerai a volere gestire i suoni o intere sezioni di suoni sulla base di eventi come questi. Un evento cue è in pratica un'indicazione che qualcosa è avvenuto. Ad esempio, per ogni volta che un loop ricomincia da capo manda un evento cue che viene registrato nel Cue Viewer. Inoltre, eventi esterni come gli eventi MIDI da una paeriferica MIDI collegata oppure eventi OSC provenienti da altri programmi o computer sono anch'essi mostrati nel Cue Viewer. E' inoltre possibile generare eneti cue usando la funzione 'cue'. Qualunque cosa appaia nel Cue Viewer può essere usato per innescare qualcosa. Questo è spiegato con maggiori dettagli nelle sezioni da 10 a 12 di questo tutorial.
