5.1 Blocchi

# Blocchi

Una struttura che vedrai molto spesso utilizzando Sonic Pi è il blocco. I blocchi ci permettono di fare delle cose molto utili con pezzi di codice notevolmente lunghi. Per esempio, abbiamo visto come con i parametri dei sintetizzatori e dei campioni eravamo in grado di cambiare qualcosa che accadeva soltanto all'interno di una singola linea di programma. Però a volte potremmo voler fare qualcosa che abbia effetto su diverse linee di programma e non una sola. Per esempio, potremmo volerle mettere in loop, aggiungerci un riverbero, avviarlo soltanto una volta ogni cinque cicli e così via. Prendi in considerazione il codice che segue:

```
play 50
sleep 0.5
sample :elec_plip
sleep 0.5
play 62
```

Per fare qualcosa con un pezzo di codice, dobbiamo dire a Sonic Pi dove il blocco inizia e finisce. Per indicare l'inizio, il linguaggio di Sonic Pi utilizza il termine 'do' mentre per indicare la fine utilizza il termine 'end'. Per esempio:

```
do
  play 50
  sleep 0.5
  sample :elec_plip
  sleep 0.5
  play 62
end
```

Tuttavia, questo ancora non è completo e infatti non è funzionante (prova tu stesso/a ad avviarlo e otterrai un errore). Infatti non abbiamo detto a Sonic Pi cosa deve fare con il blocco in questione. Dobbiamo indicare l'azione da compiere scrivendo un codice particolare dopo il 'do'. Vedremo una serie di esempi in seguito, all'interno di questa guida. Per il momento è importante sapere che avvolgendo il codice all'interno di 'do' e 'end' comunichi a Sonic Pi la tua intenzione di fare qualcosa di particolare con quelle linee di codice.
