5.3 Condizionali

# Condizionali

Una cosa che probabilmente vorrai fare è non soltanto suonare note casuali (se vuoi riguardati la sezione precedente sulla casualità) ma anche prendere decisioni casuali e basate sul risultato ottenuto da una o un'altra stringa di codice precisa. Per esempio, potresti voler suonare in maniera casuale un tamburo o un piatto. Possiamo ottenere quanto detto sopra utilizzando la funzione 'if'.

## Tirare una moneta

Quindi, tiriamo una moneta: se fosse testa, suona un tamburo, se fosse croce, suona un piatto. Facile no? Possiamo imitare il comportamento del lancio di una moneta con la funzione 'one_in' (introdotto nella sezione sulla casualità) specificando la probabilità di 1 ogni 2: 'one_in(2)'. Possiamo quindi utilizzare i risultati di questa funzione per decidere quali di due stringhe di codice scegliere, quello del tamburo o quello del piatto:

```
loop do
  if one_in(2)
    sample :drum_heavy_kick
  else
    sample :drum_cymbal_closed
  end
  
  sleep 0.5
  
end
```

Tieni conto che la struttura di 'if' è composta di tre parti:

* La domanda da chiedere
* La prima scelta del codice da eseguire (se la risposta alla domanda è sì)
* La seconda scelta del codice da eseguire (se la risposta alla domanda è no)

Di solito all'interno dei linguaggi di programmazione, la nozione di sì è definita come 'vera', mentre la nozione di no è definita come 'falsa'. Quindi dobbiamo trovare una domanda che ci dia una risposta 'vera' o 'falsa', il che è esattamente quello che la funzione 'one_in' fa.

Fai caso a come la prima scelta è inclusa tra la parola 'if' e la parola 'else' e invece la seconda scelta è tra 'else' e 'end'. Funziona ugualmente alla struttura 'do/end', dove puoi inserire più linee di codice in ogni posizione. Per esempio:

```
loop do
  if one_in(2)
    sample :drum_heavy_kick
    sleep 0.5
  else
    sample :drum_cymbal_closed
    sleep 0.25
  end
  
end
```

Nel caso precedente, abbiamo creato suoni di lunghezza diversa attraverso la funzione 'sleep' a seconda della scelta eseguta.


## Funzione 'if' semplice

A volte puoi aver bisogno di creare un'opzione per eseguire una linea di codice. Puoi fare questo costruendo la struttura di 'if' e ponendo la domanda alla fine. Per esempio:

```
use_synth :dsaw
loop do
  play 50, amp: 0.3, release: 2
  play 53, amp: 0.3, release: 2 if one_in(2)
  play 57, amp: 0.3, release: 2 if one_in(3)
  play 60, amp: 0.3, release: 2 if one_in(4)
  sleep 1.5
end
```

Il codice scritto precedentemente suonerà un accordo composto da un numero sempre differente di note dipendente dal grado diverso di probabilità attribuito all'esecuzione di ogni nota.
