2.2 シンセのオプション

# シンセのオプション: ampとpan

Sonic Piは、演奏した音符や再生したサンプルを制御可能なだけでなく、音の作成や制御のための様々なオプションを提供しています。このチュートリアルではこれらの多くを紹介していく予定です。また、ヘルプシステムにはそれぞれについての詳細なドキュメントがあります。ここでは、その中でも最も有用なものの2つ、*amplitude（音量）*と*pan（パン）*を紹介します。では最初に、オプションが実際にどのようなものか見てみましょう。


## オプション

Sonic Piはシンセのためにオプションという概念を備えています。オプションは、サウンドの特徴をコントロールしたり変更するための手段で、`play`に渡されます。シンセはそれぞれ独自に細かく音をチューニングするためのオプションを持っています。その一方で、`amp:`（音量）やエンベロープ（他の章で紹介します）のような、多くのサウンドに共通するオプションもあります。

オプションは2つの主要な部分からなり、1つはその名前（制御の名前）で、もう1つはその値（制御に設定したい値）です。例えば、`cheese:`というオプションがあったとして、`1`の値にセットしたいとします。

オプションは、`play`の後にカンマ`,`を入れて、その後、`amp:`（コロン`:`を忘れずに）のようなオプションの名前、スペース、そしてオプションの値、というように渡していきます。例えば、

```
play 50, cheese: 1
```

（`cheese:`は無効なオプションです。例として使っています）

カンマを使って区切り、複数のオプションを使用することができます。

```
play 50, cheese: 1, beans: 0.5
```

オプションの順番は問題ではないので、以下は同じものです。

```
play 50, beans: 0.5, cheese: 1
```

シンセで認識されないオプションは無視されます（`cheese`（チーズ）と`beans`（豆）などは明らかに馬鹿げた名前でしょう！）

もし偶然同じオプションを2回、違う値で使った場合は、最後のものが有効になります。例えば、ここでの`beans:`は、0.5ではなく2の値が採用されます。

```
play 50, beans: 0.5, cheese: 3, eggs: 0.1, beans: 2
```

Sonic Piの多くの命令にはオプションが用意されているので、ちょっとだけ時間を使って、その使い方を習得しましょう！ それでは最初のオプション`amp:`で演奏してみましょう。

## アンプ（音量）

アンプは音の大きさをコンピュータで表したものです。*アンプが大きいと大きな音を出し*、*アンプが小さいと静かな音を出し*ます。Sonic Piは時間と音符を数字を使って表現するので、アンプにも数字を使用します。1の値が通常の音量であるのに対して、0はサイレント（無音）です（何も聞こえませんよ）。2、10、100 というふうに、アンプを上げることができます。ただし、全体の音を増幅しすぎると、大きな音になりすぎないように、Sonic Piはコンプレッサー（圧縮）と呼ばれるエフェクトを使用して確実な音量に抑えることを覚えておいてください。これは多くの場合、音がこもって奇妙に聞こえます。ですから、圧縮を防ぐために0から0.5のような値で使用してみてください。


## 音量を上げる

音の大きさを変えるために、`amp:`オプションを使います。例として、半分の音量で演奏するために、0.5にしてみます。

```
play 60, amp: 0.5
```

倍の音量で演奏するために、2にしてみます。

```
play 60, amp: 2
```

`amp:`オプションは、関連付けられている`play`への命令だけを変更します。ですから、この例では、最初の命令は半分の音量になり、次はデフォルトの値（1）に戻ります。

```
play 60, amp: 0.5
sleep 0.5
play 65
```

もちろん、それぞれの命令で異なった`amp:`の値を設定して演奏することもできます。

```
play 50, amp: 0.1
sleep 0.25
play 55, amp: 0.2
sleep 0.25
play 57, amp: 0.4
sleep 0.25
play 62, amp: 1
```

## パンニング

もうひとつの面白いオプションは`pan:`です。ステレオで音の位置を制御します。左に音をパンすることは左のスピーカーから音が聞こえることを意味し、右にパンすれば右のスピーカーから聞こえます。値としては、-1は最も左、0は中心、1は最も右、というようにステレオの領域で表現することができます。もちろん、音の正確な位置をコントロールするために、-1から1の間のどの値でも使用することができます。

左のスピーカーから音を鳴らしてみましょう。

```
play 60, pan: -1
```

では、右のスピーカーから鳴らします。

```
play 60, pan: 1
```

最後に元の通り、中心から鳴らしてみます（デフォルトの位置です）。

```
play 60, pan: 0
```

では、続けてあなたの音のアンプやパンを変えて楽しんでみましょう！
