1.2 Utforskning av brukergrensesnittet

# Sonic Pi-grensesnittet

Sonic Pi har et svært enkelt brukergrensesnitt for koding av musikk. La oss bruke litt tid på å utforske det.

![Sonic Pi-grensesnittet](../../../etc/doc/images/tutorial/GUI.png)


* *A* - Avspillingskontroller
* *B* - Redigeringskontroller
* *C* - Info og hjelp
* *D* - Kodebehandler
* *E* - Innstillingspanelet
* *F* - Loggvisning
* *G* - Hjelpesystem
* *H* - Skopvisning
* *F* - Loggvisning

## A. Avspillingskontroller

Disse rosa knappene er hovedkontrollene for å starte og stoppe musikken. *Kjør*-knappen kjører koden i kodebehandleren, *Stopp* stopper all kjørende kode, *Lagre* for å lagre koden til en ekstern fil og *Spill inn* for å lage et opptak (en WAV-fil) av musikken som spiller.

## B. Redigeringskontroller

These orange buttons allow you to manipulate the code editor. The *Size +* and *Size -* buttons allow you to make the text bigger and smaller.

## C. Info og hjelp

De blå knappene gir tilgang til informasjon, hjelp og innstillinger. *Info*-knappen åpner vinduet med informasjon om Sonic Pi-kjerneteamet, historien, bidragsytere og arbeidsmiljøet/fellesskapet (community). *Help*-knappen veksler i hjelpesystemet (*G*) - og *Prefs*-knappen veksler i innstillingsvinduet som lar deg kontrollere noen grunnleggende systemparametre.

## D. Kodebehandleren

Dette er området hvor du skal skrive koden og komponere/fremføre musikk. Det er en enkel tekstbehandler der du kan skrive kode, slette den, klippe og lime, osv. Tenk på det som en svært grunnleggende versjon av Libreoffice eller nettbasert tekstbehandling. Tekstbehandleren vil automatisk farge opp ord basert på deres betydning i koden. Dette kan virke rart i begynnelsen, men du vil snart finne det svært nyttig. For eksempel vet du at noe er et nummer fordi det er blått.

## E. Innstillingspanel

Sonic Pi lar deg endre en rekke innstillinger som blir tilgjengelige ved å klikke på knappen *Innstillingspanel*. Når du klikker på denne knappen kommer panelet med innstillinger til syne. Klikk én gang til for å skjule det igjen. Noen eksempler på innstillinger du kan gjøre er låsing til mono og invertering av stereo, hvor mye info som skal logges, en lydstyrkekontroll, og kanalvelger på Rasberry Pi-en.

## F. Loggvisning

Når du kjører koden, vises informasjon om hva programmet gjør i logg-visningen. Som forvalg vil du se én melding for hver lyd du oppretter med nøyaktig tid for når lyden ble utløst. Dette er svært nyttig for feilsøking i koden, og for å forstå hva koden gjør.

## G. Hjelpesystem

Endelig, en av de viktigste delene av Sonic Pi-grensesnittet er hjelpesystemet som vises nederst i vinduet. Dette kan slås av og på ved å klikke på den blå "Help"-knappen. Hjelpesystemet inneholder hjelp og informasjon om alle aspekter ved Sonic Pi, inkludert denne opplæringen, en liste over tilgjengelige synther, lydklipp, eksempler, FX og en fullstendig liste over alle funksjoner Sonic Pi har for koding av musikk.

## H. Oscilloskopvisning

The scope viewer allows you to see the sound you're hearing. You can easily see that the saw wave looks like a saw and that the basic beep is a curvey sine wave. You can also see the difference between loud and quiet sounds by the size of the lines. There are 3 scopes to play with - the default is a combined scope for the left and right channels, there is a stereo scope which draws a separate scope for each channel. Finally there is a Lissajous curve scope which will show the phase relationship between the left and right channels and allows you to draw pretty pictures with sound (https://en.wikipedia.org/wiki/Lissajous_curve).

## F. Loggvisning

All internal and external events (called cues in Sonic Pi) are automatically logged in the Cue Viewer. For example, if you have a MIDI controller connected and press one of its buttons, you'll see a new cue event in the Cue Viewer telling you the name of the controller and which button you pressed. Once you've mastered the basics of making and producing sounds, you'll start to want to cue sounds or whole sections of sounds based on events such as these. A cue event is just an indication that something happened. For example, every time a live loop spins round, it sends a cue event out which is logged in the Cue Viewer. Also, external events such as MIDI messages from connected MIDI equipment and OSC messages from other programs or computers are also displayed in the Cue Viewer. It is also possible to directly generate cue events using the `cue` function. Anything that appears in the Cue Viewer can be used to trigger something happening. This is covered in more detail in Sections 10 to 12 of this tutorial.
