2.2 Synth-valg

# Synth Options: Amp and Pan

Så vell som å styre hvilken note som skal spilles eller hvilket utvalg som skal startes, tilbyr Sonic Pi en rekke alternativer for å lage og kontrollere lydene. Vi vil dekke mange av disse mulighetene i denne opplæringen, og det er omfattende dokumentasjon for hver av dem i hjelpesystemet. Men nå vil vi introdusere to av de nyttigste: *amplitude* og *pan*. Først, la oss se på hva disse mulighetene egentlig er.


## Options

Sonic Pi støtter begrepet Options (eller opts for kort) for sine synter. Opts er kontroller du legger til "play" som endre og styrer egenskapene til lyden du hører. Hver synt har sitt eget sett av opts til å finstemme lyden. Men det er felles sett med opts som deles av mange lyder, som 'amp:' og omslagsopts (dekket i en annen seksjon).

Opts har to store deler, navnet deres (navnet på kontrollen) og verdien (verdien du vil angi kontrollen under). Du kan for eksempel ha en opt kalt 'ost:' og vil sette den med en verdi på '1'.

Opts sendes for å starte 'play' ved å bruke komma ',' og deretter navnet på opt-et slik som 'amp:' (ikke glem kolon ':') og deretter et mellomrom og verdien på opt. For eksempel:

```
play 50, ost: 1
```

(Merk at "ost:' er ikke en gyldig opt, vi bruker det bare som et eksempel).

Du kan sende flere opt ved å skille dem med komma:

```
play 50, ost: 1, bønner: 0.5
```

Rekkefølgen på opt-ene spiller ingen rolle, så de følgende er identiske:

```
play 50, bønner: 0.5, ost: 1
```

Opts som ikke gjenkjennes av synth ignoreres bare (som 'ost' og 'bønner' som tydelig er latterlige som opt-navn!)

Hvis du tilfeldigvis bruker samme opt to ganger med ulike verdier, vinner den siste. For eksempel at 'bønner:' her vil ha verdien 2 i stedet for 0.5:

```
play 50, bønner: 0.5, ost: 3, egg: 0.1, bønner: 2
```

Mange ting i Sonic Pi godtar opts, så bare bruke litt tid på å lære hvordan du bruker dem, så har du konfigurert! La oss leke med vår første opt: 'amp:'.

## Utslag

Amplituden er en datagjengivelse lydstyrken i en lyd. A *høy amplitude produserer en høy lyd* og *lav amplituden produserer en lav lyd*. I Sonic Pi symboliserer tall tid og noter, og tall symboliserer amplituden. Amplituden 0 betyr stille (du hører ingenting) mens amplituden 1 er normalt volum. Du kan selv skru opp amplituden høyere 2, 10, 100. Du bør imidlertid notere at når samlede amplituden til alle lydene blir for høy, bruker Sonic Pi det som kalles en kompressor for å klemme sammen alle, slik at det ikke blir for høyt for ørene. Dette kan ofte gjøre lyden uklar og rar. Så prøv å bruke lave amplituder, dvs i området 0 til 0,5 å unngå komprimering.


## Forsterk den opp

Hvis du vil endre amplituden til en lyd, kan du bruke "amp:" opten. For eksempel for å spille med halv amplitude sett inn 0.5:

```
play 60, amp: 0.5
```

For å spille på dobbel amplitude sett inn 2:

```
play 60, amp: 2
```

"amp:"-opt-en endrer bare valget for det "play" det er tilknyttet. Så i dette første eksemplet, er det første "play"-valget halvt volum og det andre er tilbake til standard (1):

```
play 60, amp: 0.5
sleep 0.5
play 65
```

Selvfølgelig, du kan bruke forskjellige "amp:"-verdier for hver play-valg:

```
play 50, amp: 0.1
sleep 0.25
play 55, amp: 0.2
sleep 0.25
play 57, amp: 0.4
sleep 0.25
play 62, amp: 1
```

## Stereo

En annen morsom opt er ' pan:' som legger ut, panorere, en lyd i stereo. Å panorere en lyd til venstre betyr at du hører denv fra venstre høyttaler, og panorere til høyre betyr at du hører dem fra din høyre høyttaler. Våre verdier, bruker vi -1 for fullt til venste, 0 representerer sentrum, og 1 er fullt til høyre i stereofeltet. Selvfølgelig, står vi fritt til å bruke alle verdier mellom -1 og 1 for å kontrollere den nøyaktige posisjonen av lyden vår.

La oss spille et lydsignal fra venstre høyttaler:

```
play 60, pan: -1
```

Nå, la oss spille det av den høyre høyttaleren:

```
play 60, pan: 1
```

Til slutt, la oss spille den tilbake fra sentrum av begge (standardoppsettet):

```
play 60, pan: 0
```

Nå, sett i gang med å ha det gøy med å endre amplituden og panoreringen av lydene dine!
