7.3 Glijdende Opties

# Glijdende Opties

Tijdens het verkennen van de synth en FX opties is het je misschien opgevallen dat er een aantal opts zijn die eindigen op `_slide`. Je hebt deze misschien ook proberen oproepen en daarmee opgemerkt dat zij geen effect hebben. Dat is omdat zij geen normale parameters zijn, het zijn speciale opts die enkel werken wanneer je synths controlt zoals beschreven in de voorgaande sectie.

Beschouw het volgende voorbeeld:

```
s = play 60, release: 5
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Hier hoor je de toonhoogte van de synth onmiddellijk wijzigen op elke `control` appèl  . Wij willen echter dat de toonhoogte slide (glijdt) tussen de veranderingen. Vermits we de `note:` parameter controllen, om slide toe te voegen, moeten we de parameter 'note_slide' van de synth instellen:

```
s = play 60, release: 5, note_slide: 1
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Nu horen we de de noten buigen tussen de `control`aanroep. Dat klinkt lekker, niet? Je kan de slide versnellen door een kortere tijd te gebruiken zoals `note_slide: 0.2` of vertragen door een langere slide time in te stellen.

Elke parameter die controlt kan worden heeft een identieke parameter '_slide' voor jou om mee te spelen.

## Slide-en blijft plakken

Zodra u hebt een parameter '_slide' ingesteld op een lopende synth, zal het worden onthoudenen telkens wanneer u de bijbehorende parameter slide gebruikt . Als je de slide wilt stoppen moet je de waarde '_slide' op 0 instellen voor de volgende oproep van `control`.

## Sliding FX Opts

Het is ook mogelijk FX opts te slide-en:

```
with_fx :wobble, phase: 1, phase_slide: 5 do |e|
  use_synth :dsaw
  play 50, release: 5
  control e, phase: 0.025
end
```

Veel plezier met het rond slide-en van zaken voor een vloeiende overgang en een vlotte control...
