1.2 Zapoznanie z interfejsem użytkownika

# Interfejs użytkownika Sonic Pi

Sonic Pi ma bardzo prosty interfejs umożliwiający kodowanie muzyki. Poświęćmy chwilę na zapoznanie się z nim.

![Interfejs Sonic Pi](../../../etc/doc/images/tutorial/GUI.png)


* *A* - Kontrola Odtwarzania
* *B* - Kontrola Edytora
* *C* - Informacje i Pomoc
* *D* - Edytor Kodu
* *E* - Panel Preferencji (Ustawienia)
* *F* - Podgląd Logów
* *G* - System Pomocy
* *H* - Podgląd Logów
* *F* - Podgląd znaczników

## A. Kontrola Odtwarzania

Różowe przyciski zapewniają podstawową kontrolę nad uruchamianiem i zatrzymywaniem dźwięków. Jest przycisk *Run* (Uruchom), który umożliwia uruchomienie kodu znajdującego się w edytorze. Przycisk *Stop* (Zatrzymaj) pozwala na zatrzymanie aktualnie uruchomionego kodu. Przycisk *Save* (Zapisz) służy do zapisywania kodu wpisanego w edytorze do zewnętrznego pliku tekstowego. Przycisk *Record* (Nagrywaj) umożliwia nagranie aktualnie odtwarzanego dźwięku (w formacie WAV) .

## B. Kontrola Edytora

Te pomarańczowe przyciski pozwalają Ci manipulować edytorem kodu. Przyciski *Size +* i *Size -* pozwalają Ci zwiększać i zmniejszać tekst.

## C. Informacje i Pomoc

Niebieskie przyciski dają Ci dostęp do informacji, pomocy i ustawień. Naciśnięcie przycisku *Info* (Informacje) spowoduje otworzenie dodatkowego okna, które zawiera informacje dotyczące Sonic Pi - podstawowa ekipa twórców programu, historia, współtwórcy oraz społeczność. Przycisk *Help* (Pomoc) otwiera i zamyka system pomocy (*G*), który właśnie czytasz. Przycisk *Prefs* (Ustawienia) otwiera i zamyka panel preferencji, który pozwala Ci na kontrolę kilku podstawowych ustawień aplikacji.

## D. Edytor Kodu

Jest to obszar, w którym będziesz pisał kod oraz komponował i wykonywał muzykę. Jest to prosty edytor tekstowy, gdzie możesz tworzyć, kasować, wycinać, wklejać, itd. Myśl o nim jako o bardzo prostej wersji edytora Word czy Google Docs. Edytor automatycznie koloruje słowa bazując na ich znaczeniu w kodzie. Na początku może się to wydawać dziwne, ale bardzo szybko zauważysz, że jest to bardzo przydatne. Na przykład - wiesz, że dany tekst jest liczbą, ponieważ ma kolor niebieski.

## E. Panel preferencji

Sonic Pi wspiera wiele ustawień, które są dostępne po naciśnięciu przycisku *Prefs* (ustawienia). Jest to przycisk znajdujący się tuż za przyciskami Info (informacje) i Help (pomoc). Naciśnięcie go spowoduje pokazanie Panelu Ustawień, gdzie istnieje wiele opcji, które można zmieniać. Przykłady takich ustawień to: wymuszenie trybu mono, odwrócone stereo, włączanie i wyłączanie panelu logowania, a także suwak głośności i selektor dźwięku, które są dostępne tylko na platformie Raspberry Pi.

## F. Podgląd Logów

Kiedy uruchamiasz swój kod, informacja o tym, co program aktualnie robi, będzie wyświetlana w panelu z logami. Domyślnie zobaczysz wiadomość pojawiającą się dla każdego dźwięku, który stworzysz, wraz z dokładnym czasem, kiedy ten dźwięk został uruchomiony. Jest to bardzo przydatne do debugowania Twojego kodu i zrozumienia, co on robi.

## G. System Pomocy

I na koniec została jedna z najważniejszych części interfejsu Sonic Pi - system pomocy, który pojawia się w dolnym oknie. Może on zostać włączony i wyłączony za pomocą niebieskiego przycisku *Help* (pomoc). System pomocy zawiera pomoc oraz informacje dotyczące wszystkich aspektów związanych z Sonic Pi, włączając w to ten samouczek, listę dostępnych syntezatorów, sampli (próbki dźwięków), przykłady, FX (efekty) oraz listę wszystkich funkcji, jakie Sonic Pi udostępnia do tworzenia muzyki.

## H. Podgląd Zakresu

Podgląd zakresu pozwala Ci na zobaczenie dźwięków, które słyszysz. Możesz łatwo zauważyć, że dźwięki piły (saw) wyglądają jak piła oraz że podstawowy dźwięk beep jest krzywą sinusoidalną. Możesz też dostrzec różnicę pomiędzy głośnymi i cichymi dźwiękami, obserwując wielkości linii. Możesz bawić się z 3-ma typami zakresów. Domyślny zakres to kombinacja prezentująca lewy i prawy kanał. Drugi zakres to skala stereo, która rysuje oddzielne zakresy dla każdego z kanałów. Na końcu jest krzywa Lissajous, która obrazuje zależność fazową pomiędzy lewym i prawym kanałem oraz pozwala Ci na rysowanie ładnych obrazków za pomocą dźwięku (https://pl.wikipedia.org/wiki/Krzywa_Lissajous).

## I. Podgląd logów

All internal and external events (called cues in Sonic Pi) are automatically logged in the Cue Viewer. For example, if you have a MIDI controller connected and press one of its buttons, you'll see a new cue event in the Cue Viewer telling you the name of the controller and which button you pressed. Once you've mastered the basics of making and producing sounds, you'll start to want to cue sounds or whole sections of sounds based on events such as these. A cue event is just an indication that something happened. For example, every time a live loop spins round, it sends a cue event out which is logged in the Cue Viewer. Also, external events such as MIDI messages from connected MIDI equipment and OSC messages from other programs or computers are also displayed in the Cue Viewer. It is also possible to directly generate cue events using the `cue` function. Anything that appears in the Cue Viewer can be used to trigger something happening. This is covered in more detail in Sections 10 to 12 of this tutorial.
