9.2 Żywe Pętle (Live Loops)

# Żywe Pętle (Live Loops)

Dobrze, ten rozdział to prawdziwa perełka w tym samouczku. Jeśli masz przeczytać tylko jeden znajdujący się w tutorialu, powinien to być właśnie ten. Jeśli zaznajomiłeś się z poprzednim o Podstawach Kodowania Na Żywo, to `live_loop` jest prostszą metodą dokonania dokładnie tego samego, ale bez konieczności pisania tak dużej ilości kodu.

Jeśli nie przeczytałeś poprzedniego rozdziału, funkcja `live_loop` jest najlepszym sposobem na jamowanie z Sonic Pi.

Zabawmy się. Wpiszmy następujący kod do nowego bufora:

```
live_loop :foo do
  play 60
  sleep 1
end
```

Naciśnij przycisk Run. Słyszysz podstawowy bip przy każdym uderzeniu - nic szczególnego. Powstrzymaj się jednak i nie naciskaj jeszcze przycisku Stop. Zmień wartość `60` na `65` i naciśnij przycisk Run jeszcze raz.

Łał! Brzmienie zmieniło się *automatycznie*, bez utraty żadnego uderzenia. To jest Kodowanie na Żywo.

Czemu więc nie spróbować zmienić ten kawałek, aby brzmiał trochę bardziej jak linia basowa? Wystarczy, że wprowadzisz zmiany w kodzie, gdy ten wciąż jest uruchomiony:

```
live_loop :foo do
  use_synth :prophet
  play :e1, release: 8
  sleep 8
end
```

I naciśniesz przycisk Run.

Spróbujmy sprawić, aby pojawiła się odrobina odcięcia (cutoff):

```
live_loop :foo do
  use_synth :prophet
  play :e1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Ponownie naciśnij przycisk Run.

Dodajmy trochę bębnów:

```
live_loop :foo do
  sample :loop_garzul
  use_synth :prophet
  play :e1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Zmień nutę `e1` na `c1`:

```
live_loop :foo do
  sample :loop_garzul
  use_synth :prophet
  play :c1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

A teraz przestań słuchać moich propozycji i zacznij bawić się samodzielnie! Miłej zabawy!
