7.3 Optiuni de modificare progresiva sau alunecare (sliding)

# Optiuni de modificare progresiva sau alunecare (sliding)

Cand am discutat despre sintetizatoare si efecte ai observat probabil ca exista anumiti parametri al caror nume se termina cu '_slide'. Poate chiar ai incercat sa ii folosesti si nu ai remarcat niciun efect. Asta se intampla pentru ca nu sunt parametri normali, ci optiuni speciale care sunt active doar cand controlezi sintetizatoarele asa cum am explicat in sectiunea precedenta.

Sa analizam exemplul urmator:

```
s = play 60, release: 5
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Aici, poti auzi tonalitatea sintetizatorului schimbandu-se imediat dupa fiecare apel al functiei 'control'. Totusi, am dori ca tonalitatea sa alunece (slide) intre schimbari. Deoarece controlam parametrul 'note:', pentru a adauga alunecarea, trebuie sa modificam parametrul 'note_slide' al sintetizatorului:

```
s = play 60, release: 5, note_slide: 1
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Acum vom auzi notele deformate intre apelurile 'control'. Suna bine, nu? Poti grabi alunecarea folosind un timp mai scurt, cum ar fi 'note_slide: 0.2' sau sa o incetinesti folosind un timp mai mare.

Fiecare parametru care poate fi controlat are asociat si un parametru '_slide' cu care te poti juca.

## Alunecarea este persistenta

Odata ce ai setat un parametru '_slide' pentru un sintetizator care canta, el va fi retinut de fiecare data cand faci sa alunece resprectivul parametru. Pentru a opri alunecarea trebuie sa setezi '_slide' la 0 inainte de urmatorul apel 'control'.

## Modificarea progresiva a parametrilor efectelor

Si parametrii efectelor pot fi modificati progresiv:

```
with_fx :wobble, phase: 1, phase_slide: 5 do |e|
  use_synth :dsaw
  play 50, release: 5
  control e, phase: 0.025
end
```

Acum te poti juca cu alunecarea pentru tranzitii line...
