1.2 Utforska gränssnittet

# Gränssnittet till Sonic Pi

Sonic Pi har ett mycket enkelt gränssnitt för att koda musik. Låt oss spendera lite tid att utforska det.

![Gränssnittet till Sonic Pi](../../../etc/doc/images/tutorial/GUI.png)


* *A* - Musikkontroller
* *B* - Kontroller till editorn
* *C* - Info och hjälp
* *D* - Kod-editor
* *E* - Inställningspanel
* *F* - Logg
* *G* - Hjälpsystem
* *H* - Musikvy
* *F* - Logg

## A. Musikkontroller

Dessa rosa knappar är huvudkontrollerna för att starta och stoppa musiken. Det finns en *Kör*-knapp för att köra koden i editorn, *Stopp* för att stanna all körande kod, *Spara* för att spara koden till en fil och *Spela in* för att skapa en inspelning (en WAV-fil) av musiken som spelas.

## B. Kontroller till editorn

Dessa orange knappar låter dig manipulera kodredigeraren. Knapparna * Storlek + * och * Storlek - * låter dig göra texten större och mindre.

## C. Info och Hjälp

Dessa blå knappar ger dig tillgång till information, hjälp och inställningar. *Info*-knappen öppnar upp ett informationsfönster, som innehåller information om själva Sonic Pi -programmet - huvudteamet, historien, de som bidragit och gemenskapen runt Sonic Pi. *Hjälp*-knappen visar eller plockar bort hjälpsystemet (*G*). Knappen *Inställningar* visar eller plockar bort inställningarna, där du kan kontrollera vissa enkla systemfunktioner.

## D. Kod-editor

Det är här du kommer skriva din kod och komponera/framföra musik. Det är en enkel texteditor där du kan skriva, ta bort, klippa ut samt klistra in kod. Tänk på det som en mycket enkel version av Word eller Google Docs. Editorn kommer automagiskt färgsätta ord, beroende på dess betydelse i koden. Det kan tyckas konstigt till en början, men du kommer snart tycka det är mycket användbart. Exempelvis kommer du snabbt kunna se att något är ett nummer, eftersom det har en blå färg.

## E. Inställningspanel

Sonic Pi låter dig ändra ett antal inställningar som kan nås via knappen *Inställningspanel*. När du trycker på denna knapp kommer ytan med inställningar visas eller tas bort. Några exempel på inställningar är: mono-läge, invertera stereo, hur mycket information som skall loggas, volymkontroll och val av ljudenhet på Raspberry Pi.

## F. Logg

När du kör din kod visas information om vad programmet håller på med i en logg. Som standard så ser du ett meddelande för varje ljud du skapar, med en exakt tidpunkt då ljudet började spelas. Detta är mycket användbart då du vill felsöka din kod och förstå vad den gör.

## G. Hjälpsystem

En av de mest användbara delarna av Sonic Pi är hjälpsystemet, som finns i nedre delen av fönstret. Denna yta kan slås på och av genom att trycka på den blåfärgade *Hjälp*-knappen. Hjälpsystemet innehåller hjälp och information om alla aspekter av Sonic Pi, vilket inkluderar; denna handledning, en lista över syntar, samplade ljud, exempelkod, effekter och hela listan av funktioner som finns i Sonic Pi för att koda musik.

## H. Musikvy

Musikvyn låter dig se ljudet som du hör. Du kan enkelt se att ett sågtands-ljud ser ut som en såg och att ett enkelt pip-ljud ser kurvigt ut (som en sinusvåg). Man ser även skillnad på ett starkt och ett svagt ljud genom att det ger högre eller lägre svängningar. Det finns tre vyer man kan pröva - som standard visas en kombinerad vy mellan höger och vänster kanal. Det finns en stereo-vy som visar varje kanal separat. Slutligen finns även en vy som visar en s.k. Lissajous-kurva. Den visar fasrelationen mellan höger och vänster kanal, vilket ritar snygga bilder över ljudet (https://sv.wikipedia.org/wiki/Lissajouskurva).

## F. Logg

All internal and external events (called cues in Sonic Pi) are automatically logged in the Cue Viewer. For example, if you have a MIDI controller connected and press one of its buttons, you'll see a new cue event in the Cue Viewer telling you the name of the controller and which button you pressed. Once you've mastered the basics of making and producing sounds, you'll start to want to cue sounds or whole sections of sounds based on events such as these. A cue event is just an indication that something happened. For example, every time a live loop spins round, it sends a cue event out which is logged in the Cue Viewer. Also, external events such as MIDI messages from connected MIDI equipment and OSC messages from other programs or computers are also displayed in the Cue Viewer. It is also possible to directly generate cue events using the `cue` function. Anything that appears in the Cue Viewer can be used to trigger something happening. This is covered in more detail in Sections 10 to 12 of this tutorial.
